/*  $Id: component_type.cpp,v 1.7 2003/10/28 23:15:44 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "precomp.h"
#include "component_type_generic.h"
#include "API/Core/System/error.h"
/////////////////////////////////////////////////////////////////////////////
// CL_ComponentType construction:

CL_ComponentType::CL_ComponentType() : impl(new CL_ComponentType_Generic)
{
}

CL_ComponentType::~CL_ComponentType()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_ComponentType attributes:

std::map<std::string, CL_ComponentType *> CL_ComponentType::component_types;

const std::map<std::string, CL_ComponentType::SOptionType> &CL_ComponentType::get_options() const
{
	return impl->options;
}

bool CL_ComponentType::has_option(const std::string &option_name) const
{
	return impl->options.find(option_name) != impl->options.end();
}

CL_ComponentType::EDatatype CL_ComponentType::get_data_type(const std::string &option_name) const
{
	std::map<std::string, SOptionType>::iterator it = impl->options.find(option_name);
	if (it == impl->options.end()) return STRING; // throw error?
	return it->second.type;
}

std::string CL_ComponentType::get_default_value(const std::string &option_name) const
{
	std::map<std::string, SOptionType>::iterator it = impl->options.find(option_name);
	if (it == impl->options.end()) return std::string(); // throw error?
	return it->second.default_value;
}

const std::string &CL_ComponentType::get_class_name() const
{
	return impl->class_name;
}

CL_ComponentType::EDatatype CL_ComponentType::get_data_type(const std::string &type, const std::string &option_name)
{
	std::map<std::string, CL_ComponentType *>::const_iterator it(component_types.find(type));
	if (it == component_types.end()) cl_throw_error(std::string("Could not find component type ") + type);

	return it->second->get_data_type(option_name);
}

std::string CL_ComponentType::get_default_value(const std::string &type, const std::string &option_name)
{
	std::map<std::string, CL_ComponentType *>::const_iterator it(component_types.find(type));
	if (it == component_types.end()) cl_throw_error(std::string("Could not find component type ") + type);

	return it->second->get_default_value(option_name);
}

const std::string &CL_ComponentType::get_class_name(const std::string &type)
{
	std::map<std::string, CL_ComponentType *>::const_iterator it(component_types.find(type));
	if (it == component_types.end()) cl_throw_error(std::string("Could not find component type ") + type);

	return it->second->get_class_name();
}

/////////////////////////////////////////////////////////////////////////////
// CL_ComponentType operations:

CL_Component *CL_ComponentType::create_component(
	const std::string &type,
	CL_Component *parent,
	CL_StyleManager *style)
{
	std::map<std::string, CL_ComponentType *>::const_iterator it(component_types.find(type));
	if (it == component_types.end()) cl_throw_error(std::string("Failed to create component of type ") + type);
	
	return (*it).second->create_component(parent, style);
}

void CL_ComponentType::set_option(const std::string &name, EDatatype datatype, const std::string &value)
{
	impl->options[name].type = datatype;
	impl->options[name].default_value = value;
}

void CL_ComponentType::set_class_name(const std::string &class_name)
{
	impl->class_name = class_name;
}

/////////////////////////////////////////////////////////////////////////////
//  CL_ComponentType implementation:
